diff --git a/ldap/servers/plugins/replication/urp.c b/ldap/servers/plugins/replication/urp.c
index 0e76699..3d63c64 100644
--- a/ldap/servers/plugins/replication/urp.c
+++ b/ldap/servers/plugins/replication/urp.c
@@ -23,12 +23,25 @@
 extern int slapi_log_urp;
 
 static int urp_add_resolve_parententry(Slapi_PBlock *pb, char *sessionid, Slapi_Entry *entry, Slapi_Entry *parententry, CSN *opcsn);
-static int urp_annotate_dn(char *sessionid, const Slapi_Entry *entry, CSN *opcsn, const char *optype);
+static int urp_add_check_tombstone(Slapi_PBlock *pb, char *sessionid, Slapi_Entry *entry, CSN *opcsn);
+static int urp_delete_check_conflict(char *sessionid, Slapi_Entry *tombstone_entry, CSN *opcsn);
+static int urp_add_new_entry_to_conflict(Slapi_PBlock *pb, char *sessionid, Slapi_Entry *addentry, CSN *opcsn);
+static int urp_annotate_dn(char *sessionid, const Slapi_Entry *entry, CSN *opcsn, const char *optype, char **conflict_dn);
+static int urp_conflict_to_glue(char *sessionid, const Slapi_Entry *entry, Slapi_DN *parentdn, CSN *opcsn);
+static char *urp_find_tombstone_for_glue(Slapi_PBlock *pb, char *sessionid, const Slapi_Entry *entry, Slapi_DN *parentdn, CSN *opcsn);
+static char *urp_find_valid_entry_to_delete(Slapi_PBlock *pb, const Slapi_Entry *deleteentry, char *sessionid, CSN *opcsn);
 static int urp_naming_conflict_removal(Slapi_PBlock *pb, char *sessionid, CSN *opcsn, const char *optype);
 static int mod_namingconflict_attr(const char *uniqueid, const Slapi_DN *entrysdn, const Slapi_DN *conflictsdn, CSN *opcsn, const char *optype);
+static int mod_objectclass_attr(const char *uniqueid, const Slapi_DN *entrysdn, const Slapi_DN *conflictsdn, CSN *opcsn, const char *optype);
 static int del_replconflict_attr(const Slapi_Entry *entry, CSN *opcsn, int opflags);
-static char *get_dn_plus_uniqueid(char *sessionid, const Slapi_DN *oldsdn, const char *uniqueid);
+static char *get_dn_plus_uniqueid(char *sessionid,const Slapi_DN *oldsdn,const char *uniqueid);
 static int is_suffix_entry(Slapi_PBlock *pb, Slapi_Entry *entry, Slapi_DN **parenddn);
+static int is_renamed_entry(Slapi_PBlock *pb, Slapi_Entry *entry, CSN *opcsn);
+static int urp_fixup_add_cenotaph(Slapi_PBlock *pb, char *sessionid, CSN *opcsn);
+static int is_deleted_at_csn(const Slapi_Entry *entry, CSN *opcsn);
+static char * urp_get_valid_parent_nsuniqueid(Slapi_DN *parentdn);
+static int urp_rename_conflict_children(const char *old_parent, const Slapi_DN *new_parent);
+static Slapi_Entry *urp_get_min_naming_conflict_entry(Slapi_PBlock *pb, const char *collision_dn, char *sessionid, CSN *opcsn);
 
 /*
  * Return 0 for OK, -1 for Error.
@@ -84,14 +97,12 @@ urp_add_operation(Slapi_PBlock *pb)
     Slapi_Entry *existing_uniqueid_entry;
     Slapi_Entry *existing_dn_entry;
     Slapi_Entry *addentry;
-    const char *adduniqueid;
     CSN *opcsn;
     const char *basedn;
     char sessionid[REPL_SESSION_ID_SIZE];
     int r;
     int op_result = 0;
     int rc = 0; /* OK */
-    Slapi_DN *sdn = NULL;
 
     if (slapi_op_abandoned(pb)) {
         return rc;
@@ -124,6 +135,36 @@ urp_add_operation(Slapi_PBlock *pb)
 
     slapi_pblock_get(pb, SLAPI_ADD_ENTRY, &addentry);
     slapi_pblock_get(pb, SLAPI_ADD_EXISTING_DN_ENTRY, &existing_dn_entry);
+
+    slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                   "urp_add_operation - handling add of (%s).\n",
+                   slapi_entry_get_dn_const(addentry));
+    /* first check if there was an existing entry at the time of this add 
+     * in that case the new entry will become a conflict entry independent 
+     * of the case if the other entry still exists
+     */
+    rc = urp_add_check_tombstone(pb, sessionid, addentry, opcsn);
+    if (rc == 1) {
+        /* the new entry is conflicting with an already deleted entry
+         * transform to conflict entry
+          */
+        rc = urp_add_new_entry_to_conflict(pb, sessionid, addentry, opcsn);
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                       "urp_add_operation - new entry to conflictentry (%s).\n",
+                       slapi_entry_get_dn_const(addentry));
+        goto bailout;
+    } else if (rc == 2) {
+        /* the tombstone is newer than the added entry
+         * inform the caller that this needs to become a tombstone operation
+         * and turn the tombstone to a conflict
+         */
+        rc = SLAPI_PLUGIN_NOOP_TOMBSTONE;
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                       "urp_add_operation - new entry to tombstone (%s).\n",
+                       slapi_entry_get_dn_const(addentry));
+        goto bailout;
+    }
+
     if (existing_dn_entry == NULL) /* The target DN does not exist */
     {
         /* Check for parent entry... this could be an orphan. */
@@ -141,80 +182,26 @@ urp_add_operation(Slapi_PBlock *pb)
      * its RDN to uniqueid+baserdn, and adds operational attribute
      * ATTR_NSDS5_REPLCONFLIC.
      */
-    basedn = slapi_entry_get_ndn(addentry);
-    adduniqueid = slapi_entry_get_uniqueid(addentry);
-    r = csn_compare(entry_get_dncsn(existing_dn_entry), opcsn);
+    basedn = slapi_entry_get_ndn (addentry);
+    r = csn_compare (entry_get_dncsn(existing_dn_entry), opcsn);
     if (r < 0) {
         /* Entry to be added is a loser */
-        char *newdn = get_dn_plus_uniqueid(sessionid, (const Slapi_DN *)addentry, adduniqueid);
-        if (newdn == NULL) {
-            op_result = LDAP_OPERATIONS_ERROR;
-            slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
-            rc = SLAPI_PLUGIN_NOOP; /* Abort this Operation */
-            slapi_log_err(slapi_log_urp, sessionid,
-                          "urp_add_operation - %s - Add conflict; Unique ID (%s) already in RDN\n",
-                          basedn, adduniqueid);
-            PROFILE_POINT; /* Add Conflict; Entry Exists; Unique ID already in RDN - Abort this update. */
-        } else {
-            /* Add the nsds5ReplConflict attribute in the mods */
-            Slapi_Attr *attr = NULL;
-            Slapi_Value **vals = NULL;
-            Slapi_RDN *rdn;
-            char buf[BUFSIZ];
-
-#ifdef DEBUG
-            PR_snprintf(buf, BUFSIZ, "%s (add) %s", REASON_ANNOTATE_DN, basedn);
-#else
-            PR_snprintf(buf, BUFSIZ, "%s %s", REASON_ANNOTATE_DN, basedn);
-#endif
-            if (slapi_entry_attr_find(addentry, ATTR_NSDS5_REPLCONFLICT, &attr) == 0) {
-                /* ATTR_NSDS5_REPLCONFLICT exists */
-                slapi_log_err(SLAPI_LOG_ERR, sessionid,
-                              "urp_add_operation - New entry has nsds5ReplConflict already\n");
-                vals = attr_get_present_values(attr); /* this returns a pointer to the contents */
-            }
-            if (vals == NULL || *vals == NULL) {
-                /* Add new attribute */
-                slapi_entry_add_string(addentry, ATTR_NSDS5_REPLCONFLICT, buf);
-            } else {
-                /*
-                 * Replace old attribute. We don't worry about the index
-                 * change here since the entry is yet to be added.
-                 */
-                slapi_value_set_string(*vals, buf);
-            }
-            /* slapi_pblock_get(pb, SLAPI_ADD_TARGET, &dn); */
-            slapi_pblock_get(pb, SLAPI_ADD_TARGET_SDN, &sdn);
-            slapi_sdn_free(&sdn);
-
-            slapi_entry_set_normdn(addentry, newdn); /* dn: passin */
-
-            sdn = slapi_sdn_dup(slapi_entry_get_sdn_const(addentry));
-            slapi_pblock_set(pb, SLAPI_ADD_TARGET_SDN, sdn);
-
-            rdn = slapi_rdn_new_sdn(slapi_entry_get_sdn_const(addentry));
-            slapi_log_err(slapi_log_urp, sessionid,
-                          "urp_add_operation - Naming conflict ADD. Add %s instead\n",
-                          slapi_rdn_get_rdn(rdn));
-            slapi_rdn_free(&rdn);
-
-            rc = slapi_setbit_int(rc, SLAPI_RTN_BIT_FETCH_EXISTING_DN_ENTRY);
-            PROFILE_POINT; /* Add Conflict; Entry Exists; Rename Operation Entry */
-        }
+        rc = urp_add_new_entry_to_conflict(pb, sessionid, addentry, opcsn);
     } else if (r > 0) {
+        char *conflict_dn = NULL;
         /* Existing entry is a loser */
-        if (!urp_annotate_dn(sessionid, existing_dn_entry, opcsn, "ADD")) {
-            op_result = LDAP_OPERATIONS_ERROR;
+        if (!urp_annotate_dn(sessionid, existing_dn_entry, opcsn, "ADD", &conflict_dn)) {
+            op_result= LDAP_OPERATIONS_ERROR;
             slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
             slapi_log_err(slapi_log_urp, sessionid,
-                          "urp_add_operation - %s - Entry to be added is a loser; "
-                          "urp_annotate_dn failed.\n",
-                          basedn);
+                           "urp_add_operation - %s - Entry to be added is a loser; "
+                           "urp_annotate_dn failed.\n", basedn);
             rc = SLAPI_PLUGIN_NOOP; /* Ignore this Operation */
         } else {
             /* The backend add code should now search for the existing entry again. */
-            rc = slapi_setbit_int(rc, SLAPI_RTN_BIT_FETCH_EXISTING_DN_ENTRY);
-            rc = slapi_setbit_int(rc, SLAPI_RTN_BIT_FETCH_PARENT_ENTRY);
+            rc= slapi_setbit_int(rc,SLAPI_RTN_BIT_FETCH_EXISTING_DN_ENTRY);
+            rc= slapi_setbit_int(rc,SLAPI_RTN_BIT_FETCH_PARENT_ENTRY);
+            slapi_pblock_set(pb, SLAPI_URP_NAMING_COLLISION_DN, conflict_dn);
         }
         PROFILE_POINT; /* Add Conflict; Entry Exists; Rename Existing Entry */
     } else             /* r==0 */
@@ -258,7 +245,7 @@ urp_modrdn_operation(Slapi_PBlock *pb)
     Slapi_Entry *new_parent_entry;
     Slapi_DN *newsuperior = NULL;
     Slapi_DN *parentdn = NULL;
-    const Slapi_Entry *target_entry;
+    Slapi_Entry *target_entry;
     Slapi_Entry *existing_entry;
     const CSN *target_entry_dncsn;
     CSN *opcsn = NULL;
@@ -320,6 +307,12 @@ urp_modrdn_operation(Slapi_PBlock *pb)
     slapi_pblock_get(pb, SLAPI_MODRDN_NEWPARENT_ENTRY, &new_parent_entry);
     slapi_pblock_get(pb, SLAPI_MODRDN_NEWSUPERIOR_SDN, &newsuperior);
 
+    if (is_conflict_entry (target_entry)) {
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                      "urp_modrdn_operation  - Target_entry %s is a conflict; what to do ?\n",
+                      slapi_entry_get_dn((Slapi_Entry *)target_entry));
+    }
+
     if (is_tombstone_entry(target_entry)) {
         /*
          * It is a non-trivial task to rename a tombstone.
@@ -329,21 +322,36 @@ urp_modrdn_operation(Slapi_PBlock *pb)
          */
 
         /* Turn the tombstone to glue before rename it */
-        /*
-        op_result = tombstone_to_glue (pb, sessionid, target_entry,
-            slapi_entry_get_sdn (target_entry), "renameTombstone", opcsn);
-        */
-        op_result = LDAP_NO_SUCH_OBJECT;
-        slapi_log_err(SLAPI_LOG_REPL, sessionid,
-                      "urp_modrdn_operation  - Target_entry %s is a tombstone; returning LDAP_NO_SUCH_OBJECT.\n",
-                      slapi_entry_get_dn((Slapi_Entry *)target_entry));
+        /* check if the delete was after the modrdn */
+        char *del_str = slapi_entry_attr_get_charptr(target_entry, "nstombstonecsn");
+        CSN *del_csn = csn_new_by_string(del_str);
+        if (csn_compare(del_csn,opcsn)>0) {
+            char *glue_dn = slapi_entry_attr_get_charptr(target_entry, "nscpentrydn");
+            Slapi_DN *glue_sdn = slapi_sdn_new_dn_byval(glue_dn);
+            op_result = tombstone_to_glue (pb, sessionid, target_entry,
+                                           glue_sdn, "renameTombstone", opcsn, NULL);
+            slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                          "urp_modrdn_operation  - Target_entry %s is a tombstone; Renaming since delete was after rename.\n",
+                           slapi_entry_get_dn((Slapi_Entry *)target_entry));
+            slapi_ch_free_string(&glue_dn);
+            slapi_sdn_free(&glue_sdn);
+        } else {
+            op_result = LDAP_NO_SUCH_OBJECT;
+            slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                          "urp_modrdn_operation  - Target_entry %s is a tombstone; returning LDAP_NO_SUCH_OBJECT.\n",
+                          slapi_entry_get_dn((Slapi_Entry *)target_entry));
+        }
+        slapi_ch_free_string(&del_str);
+        csn_free(&del_csn);
+
         slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
+
         if (op_result == 0) {
             /*
              * Remember to turn this entry back to tombstone in post op.
-             * We'll just borrow an obsolete pblock type here.
+             * We'll just borrow an obsolete pblock type here. ???
              */
-            slapi_pblock_set(pb, SLAPI_URP_TOMBSTONE_UNIQUEID, slapi_ch_strdup(op_uniqueid));
+            /* no. slapi_pblock_set (pb, SLAPI_URP_TOMBSTONE_UNIQUEID, slapi_ch_strdup(op_uniqueid)); */
             rc = slapi_setbit_int(rc, SLAPI_RTN_BIT_FETCH_TARGET_ENTRY);
             rc = 0;
         } else {
@@ -362,9 +370,15 @@ urp_modrdn_operation(Slapi_PBlock *pb)
          * An entry with the target DN already exists.
          * The smaller dncsn wins. The loser changes its RDN to
          * uniqueid+baserdn, and adds operational attribute
-         * ATTR_NSDS5_REPLCONFLIC
+         * ATTR_NSDS5_REPLCONFLICT
          */
 
+        if (is_conflict_entry (existing_entry)) {
+            slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                          "urp_modrdn_operation  - Existing_entry %s is a conflict; what to do ?\n",
+                          slapi_entry_get_dn((Slapi_Entry *)existing_entry));
+        }
+
         existing_uniqueid = slapi_entry_get_uniqueid(existing_entry);
         existing_sdn = slapi_entry_get_sdn_const(existing_entry);
 
@@ -413,6 +427,7 @@ urp_modrdn_operation(Slapi_PBlock *pb)
                 goto bailout;
             }
             mod_namingconflict_attr(op_uniqueid, target_sdn, existing_sdn, opcsn, "MODRDN");
+            mod_objectclass_attr(op_uniqueid, target_sdn, target_sdn, opcsn, "MODRDN");
             slapi_pblock_set(pb, SLAPI_MODRDN_NEWRDN, newrdn_with_uniqueid);
             slapi_log_err(slapi_log_urp, sessionid,
                           "urp_modrdn_operation - Naming conflict MODRDN. Rename target entry from %s to %s\n",
@@ -425,7 +440,7 @@ urp_modrdn_operation(Slapi_PBlock *pb)
         if (r > 0) {
             /* The existing entry is a loser */
 
-            int resolve = urp_annotate_dn(sessionid, existing_entry, opcsn, "MODRDN");
+            int resolve = urp_annotate_dn(sessionid, existing_entry, opcsn, "MODRDN", NULL);
             if (!resolve) {
                 op_result = LDAP_OPERATIONS_ERROR;
                 slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
@@ -541,7 +556,7 @@ bailout:
 int
 urp_delete_operation(Slapi_PBlock *pb)
 {
-    const Slapi_Entry *deleteentry;
+    Slapi_Entry *deleteentry;
     CSN *opcsn = NULL;
     char sessionid[REPL_SESSION_ID_SIZE];
     int op_result = 0;
@@ -564,13 +579,42 @@ urp_delete_operation(Slapi_PBlock *pb)
                       slapi_entry_get_dn((Slapi_Entry *)deleteentry));
         PROFILE_POINT; /* Delete Operation; Entry not exist. */
     } else if (is_tombstone_entry(deleteentry)) {
-        /* The entry is already a Tombstone, ignore this delete. */
-        op_result = LDAP_ALREADY_EXISTS;
-        slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
-        rc = SLAPI_PLUGIN_NOOP; /* Don't apply the Delete */
-        slapi_log_err(slapi_log_urp, sessionid,
-                      "urp_delete_operation - Entry \"%s\" is already a Tombstone.\n",
-                      slapi_entry_get_dn_const(deleteentry));
+        /* The entry is already a Tombstone,
+         * either because the operation was already applied,
+         * then ignore this delete.
+         * check if the tombstone csn matches the operationcsn
+         */
+        if (is_deleted_at_csn(deleteentry, opcsn)) {
+            op_result= LDAP_ALREADY_EXISTS;
+            slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
+            rc = SLAPI_PLUGIN_NOOP; /* Don't apply the Delete */
+            slapi_log_err(slapi_log_urp, sessionid,
+                           "urp_delete_operation - Entry \"%s\" is already a Tombstone.\n",
+                           slapi_entry_get_dn_const(deleteentry));
+        } else if (urp_delete_check_conflict (sessionid, deleteentry, opcsn)) {
+            /* the other option is that an entry was turned into a conflict
+             * when a conflicting  add was handled for an already delted entry
+             * This means that now the conflict has also to be turned into a tombstone
+             * Check if such a conflict exists - and turn to a tombstone
+             */
+            op_result= LDAP_SUCCESS;
+            slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
+            rc = SLAPI_PLUGIN_NOOP_COMMIT; /* Don't apply the Delete */
+            slapi_log_err(slapi_log_urp, sessionid,
+                           "urp_delete_operation - Deleted conflict entry instead of tombstone \"%s\"\n",
+                           slapi_entry_get_dn_const(deleteentry));
+        } else {
+            /* no already deleted tombstone and no alternative to delete
+             * do nothing
+             */
+            op_result= LDAP_OPERATIONS_ERROR;
+            slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
+            rc = SLAPI_PLUGIN_NOOP; /* Don't apply the Delete */
+            slapi_log_err(slapi_log_urp, sessionid,
+                           "urp_delete_operation - Entry \"%s\" cannot be deleted.\n",
+                           slapi_entry_get_dn_const(deleteentry));
+        }
+
         PROFILE_POINT; /* Delete Operation; Already a Tombstone. */
     } else             /* The entry to be deleted exists and is not a tombstone */
     {
@@ -579,26 +623,128 @@ urp_delete_operation(Slapi_PBlock *pb)
         /* Check if the entry has children. */
         if (!slapi_entry_has_children(deleteentry)) {
             /* Remove possible conflict attributes */
-            del_replconflict_attr(deleteentry, opcsn, 0);
             rc = SLAPI_PLUGIN_SUCCESS; /* OK, to delete the entry */
-            PROFILE_POINT;             /* Delete Operation; OK. */
+            if (is_conflict_entry(deleteentry)) {
+                Slapi_DN *sdn = NULL;
+                slapi_pblock_get(pb, SLAPI_DELETE_TARGET_SDN, &sdn);
+                if (0 == slapi_sdn_compare(sdn, slapi_entry_get_sdn(deleteentry))) {
+                    /* the delete directly targetd the conflict entry, just continue */
+                } else {
+                    /* check if there is a valid entry added before the delete,
+                     * then we need to delete this entry
+                     */
+                    char *valid_uniqueid = urp_find_valid_entry_to_delete(pb, deleteentry, sessionid, opcsn);
+                    if (valid_uniqueid) {
+                        /* do we need to free SLAPI_TARGET_UNIQUEID ? */
+                        slapi_pblock_set( pb, SLAPI_TARGET_UNIQUEID, (void*)valid_uniqueid);
+                        rc = slapi_setbit_int(rc,SLAPI_RTN_BIT_FETCH_EXISTING_UNIQUEID_ENTRY);
+                    } else { 
+                        del_replconflict_attr (deleteentry, opcsn, 0);
+                        rc= slapi_setbit_int(rc,SLAPI_RTN_BIT_FETCH_EXISTING_DN_ENTRY);
+                    }
+                }
+            }  else if (is_renamed_entry(pb, deleteentry, opcsn)) {
+                /* the entry was renamed before the delete, ignore the delete */
+                op_result= LDAP_SUCCESS;
+                slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
+                rc = SLAPI_PLUGIN_NOOP; /* Don't apply the Delete */
+            }
+            PROFILE_POINT; /* Delete Operation; OK. */
         } else {
-            /* Turn this entry into a glue_absent_parent entry */
-            entry_to_glue(sessionid, deleteentry, REASON_RESURRECT_ENTRY, opcsn);
+            /* the entry has children, so it is either the orphan-glue
+             * scenario or the more complex situatin when there is a conflict entry
+             * for the entry to be deleted which would be restored in the post_delete
+             * phase. We would just have to swap the entries and be done,
+             * but unfortunately as a plugin this is not possible.
+             * So the approach is:
+             * - move the children to th conflict entry
+             * - let the delete happen
+             * - let the post_del rename the conflict entry
+             */
+            Slapi_Entry *conflict_entry = urp_get_min_naming_conflict_entry (pb, slapi_entry_get_dn_const(deleteentry), sessionid, opcsn);
+            if (conflict_entry) {
+                urp_rename_conflict_children(slapi_entry_get_dn_const(deleteentry),
+                                             slapi_entry_get_sdn_const(conflict_entry));
+                slapi_entry_free(conflict_entry);
+                rc = SLAPI_PLUGIN_SUCCESS; /* OK, to delete the entry */
+            } else {
+                /* Turn this entry into a glue_absent_parent entry */
+                rc = entry_to_glue(sessionid, deleteentry, REASON_RESURRECT_ENTRY, opcsn);
 
-            /* Turn the Delete into a No-Op */
-            op_result = LDAP_SUCCESS;
-            slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
-            rc = SLAPI_PLUGIN_NOOP; /* Don't apply the Delete */
-            slapi_log_err(slapi_log_urp, sessionid,
-                          "urp_delete_operation - Turn entry \"%s\" into a glue_absent_parent entry.\n",
-                          slapi_entry_get_dn_const(deleteentry));
-            PROFILE_POINT; /* Delete Operation; Entry has children. */
+                /* Turn the Delete into a No-Op */
+                op_result= LDAP_SUCCESS;
+                slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
+                if (rc == 0) {
+                    /* Don't apply the Delete, but commit the glue change */
+                    rc = SLAPI_PLUGIN_NOOP_COMMIT;
+                } else {
+                    rc = SLAPI_PLUGIN_NOOP; /* Don't apply the Delete */
+                }
+                slapi_log_err(slapi_log_urp, sessionid,
+                               "urp_delete_operation - Turn entry \"%s\" into a glue_absent_parent entry.\n",
+                                 slapi_entry_get_dn_const(deleteentry));
+                PROFILE_POINT; /* Delete Operation; Entry has children. */
+            }
         }
     }
     return rc;
 }
 
+
+/*
+ * Return 0 for OK, -1 for Error
+ */
+int
+urp_post_add_operation(Slapi_PBlock *pb)
+{
+    char sessionid[REPL_SESSION_ID_SIZE];
+    Slapi_Operation *op;
+    CSN *opcsn;
+    Slapi_Entry *addentry;
+    char *conflict_dn = NULL;
+    const char *valid_dn = NULL;
+    int rc = 0;
+
+    slapi_pblock_get( pb, SLAPI_URP_NAMING_COLLISION_DN, &conflict_dn );
+
+    if (conflict_dn) {
+        /* the existing entry was turned into a conflict,
+         * move children to the valid entry
+         */
+        slapi_pblock_get( pb, SLAPI_OPERATION, &op);
+        get_repl_session_id (pb, sessionid, &opcsn);
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                      "urp_post_add_operation - Entry %s is conflict entry, check for children\n",
+                      conflict_dn);
+        slapi_pblock_get( pb, SLAPI_ADD_ENTRY, &addentry );
+        valid_dn = slapi_entry_get_dn_const(addentry);
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                      "urp_post_add_operation - Entry %s is valid entry, check for children\n",
+                      valid_dn);
+        rc = urp_rename_conflict_children(conflict_dn, slapi_entry_get_sdn_const(addentry));
+    }
+    slapi_ch_free_string(&conflict_dn);
+    slapi_pblock_set( pb, SLAPI_URP_NAMING_COLLISION_DN, NULL );
+    slapi_pblock_get( pb, SLAPI_URP_TOMBSTONE_CONFLICT_DN, &conflict_dn );
+
+    if (conflict_dn) {
+    /* a tombstone was tirned into a conflict
+     * move it to a valid parent if parent is also a conflict
+     */
+        Slapi_DN *conflict_sdn = slapi_sdn_new_dn_byval(conflict_dn);
+        char *parent_dn = slapi_dn_parent(conflict_dn);
+        slapi_pblock_get( pb, SLAPI_OPERATION, &op);
+        get_repl_session_id (pb, sessionid, &opcsn);
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                      "urp_post_add_operation - Entry %s is conflict from tombstone, check parent\n",
+                      conflict_dn);
+        rc = tombstone_to_conflict_check_parent(sessionid, parent_dn, NULL, NULL, opcsn, conflict_sdn);
+        slapi_sdn_free(&conflict_sdn);
+        slapi_ch_free_string(&parent_dn);
+    }
+    return rc;
+}
+
 int
 urp_post_modrdn_operation(Slapi_PBlock *pb)
 {
@@ -607,6 +753,12 @@ urp_post_modrdn_operation(Slapi_PBlock *pb)
     char *tombstone_uniqueid;
     Slapi_Entry *postentry;
     Slapi_Operation *op;
+    int rc = SLAPI_PLUGIN_SUCCESS; /* OK */
+    int oprc = 0;
+
+    /* only execute if operation was successful */
+    slapi_pblock_get(pb, SLAPI_PLUGIN_OPRETURN, &oprc);
+    if (oprc) return rc;
 
     /*
      * Do not abandon the post op - the processed CSN needs to be
@@ -626,6 +778,10 @@ urp_post_modrdn_operation(Slapi_PBlock *pb)
         if (!operation_is_flag_set(op, OP_FLAG_REPL_FIXUP)) {
             get_repl_session_id(pb, sessionid, &opcsn);
             urp_naming_conflict_removal(pb, sessionid, opcsn, "MODRDN");
+            /* keep track of the entry's lifetime befor renaming
+             * by creating a cenotaph
+             */
+            urp_fixup_add_cenotaph(pb, sessionid, opcsn);
         }
     } else {
         /*
@@ -642,7 +798,7 @@ urp_post_modrdn_operation(Slapi_PBlock *pb)
         slapi_pblock_set(pb, SLAPI_URP_TOMBSTONE_UNIQUEID, NULL);
     }
 
-    return 0;
+    return rc;
 }
 
 /*
@@ -656,6 +812,11 @@ urp_post_delete_operation(Slapi_PBlock *pb)
     CSN *opcsn;
     char sessionid[REPL_SESSION_ID_SIZE];
     int op_result;
+    int oprc = 0;
+
+    /* only execute if operation was successful */
+    slapi_pblock_get(pb, SLAPI_PLUGIN_OPRETURN, &oprc);
+    if (oprc) return 0;
 
     /*
      * Do not abandon the post op - the processed CSN needs to be
@@ -692,6 +853,74 @@ urp_post_delete_operation(Slapi_PBlock *pb)
     return 0;
 }
 
+static int
+urp_fixup_add_cenotaph (Slapi_PBlock *pb, char *sessionid, CSN *opcsn)
+{
+    Slapi_PBlock *add_pb = slapi_pblock_new();
+    Slapi_Entry *cenotaph = NULL;
+    Slapi_Entry *pre_entry = NULL;
+    int ret = 0;
+    Slapi_DN *pre_sdn = NULL;
+    Slapi_RDN *rdn = slapi_rdn_new();
+    char *parentdn = NULL;
+    char *newdn;
+    const char *entrydn;
+    const char *uniqueid = NULL;
+    CSN *dncsn = NULL;
+    char csnstr[CSN_STRSIZE+1];
+
+    slapi_pblock_get (pb, SLAPI_ENTRY_PRE_OP, &pre_entry);
+    if (pre_entry == NULL) {
+        slapi_log_err(SLAPI_LOG_ERR, sessionid,
+                       "urp_fixup_add_cenotaph - failed to get preop entry\n");
+        return -1;
+    }
+
+    slapi_pblock_get(pb, SLAPI_MODRDN_TARGET_SDN, &pre_sdn);
+    entrydn = slapi_sdn_get_ndn(pre_sdn);
+    /* pre_sdn = slapi_entry_get_sdn(pre_entry); 
+       entrydn = slapi_entry_get_ndn (pre_entry);*/
+    uniqueid = slapi_entry_get_uniqueid (pre_entry);
+    parentdn = slapi_dn_parent(entrydn);
+    slapi_sdn_get_rdn(pre_sdn, rdn);
+    slapi_rdn_remove_attr (rdn, SLAPI_ATTR_UNIQUEID );
+    slapi_rdn_add(rdn, "cenotaphID", uniqueid);
+    newdn = slapi_ch_smprintf("%s,%s", slapi_rdn_get_rdn(rdn), parentdn);
+    slapi_ch_free_string(&parentdn);
+    /* slapi_sdn_free(&pre_sdn); */
+
+    cenotaph = slapi_entry_alloc();
+    slapi_entry_init(cenotaph, newdn, NULL);
+
+    dncsn = (CSN *)entry_get_dncsn (pre_entry);
+    slapi_entry_add_string(cenotaph, SLAPI_ATTR_OBJECTCLASS, "extensibleobject");
+    slapi_entry_add_string(cenotaph, SLAPI_ATTR_OBJECTCLASS, "nstombstone");
+    slapi_entry_add_string(cenotaph,"cenotaphfrom", csn_as_string(dncsn, PR_FALSE, csnstr));
+    slapi_entry_add_string(cenotaph,"cenotaphto", csn_as_string(opcsn, PR_FALSE, csnstr));
+    slapi_entry_add_string(cenotaph,"nstombstonecsn", csn_as_string(opcsn, PR_FALSE, csnstr));
+    slapi_entry_add_string(cenotaph, SLAPI_ATTR_NSCP_ENTRYDN, entrydn);
+
+    slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                   "urp_fixup_add_cenotaph - addinng cenotaph: %s \n", newdn);
+    slapi_pblock_init(add_pb);
+
+    slapi_add_entry_internal_set_pb(add_pb,
+                                    cenotaph,
+                                    NULL,
+                                    repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                    OP_FLAG_REPL_FIXUP|OP_FLAG_NOOP);
+    slapi_add_internal_pb(add_pb);
+    slapi_pblock_get(add_pb, SLAPI_PLUGIN_INTOP_RESULT, &ret);
+
+    if (ret != LDAP_SUCCESS) {
+        slapi_log_err(SLAPI_LOG_ERR, sessionid,
+                       "urp_fixup_add_cenotaph - failed to add cenotaph, err= %d\n", ret);
+    }
+    slapi_pblock_destroy(add_pb);
+
+    return ret;
+}
+
 int
 urp_fixup_add_entry(Slapi_Entry *e, const char *target_uniqueid, const char *parentuniqueid, CSN *opcsn, int opflags)
 {
@@ -730,6 +959,50 @@ urp_fixup_add_entry(Slapi_Entry *e, const char *target_uniqueid, const char *par
 }
 
 int
+urp_fixup_modrdn_entry (const Slapi_DN *entrydn, const char *newrdn, const Slapi_DN *newsuperior, const char *entryuniqueid, const char *parentuniqueid, CSN *opcsn, int opflags)
+{
+    Slapi_PBlock *newpb;
+    Slapi_Operation *op;
+    int op_result;
+
+    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
+                  "urp_fixup_modrdn_entry: moving entry (%s) to (%s) as (%s)\n",
+                   slapi_sdn_get_dn(entrydn), slapi_sdn_get_dn(newsuperior),newrdn);
+    /* log only
+    return 0; */
+    newpb = slapi_pblock_new();
+
+    slapi_rename_internal_set_pb_ext(newpb,
+                                     entrydn,
+                                     newrdn,
+                                     newsuperior,
+                                     0,
+                                     NULL,
+                                     entryuniqueid,
+                                     repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                     OP_FLAG_REPLICATED | OP_FLAG_REPL_FIXUP | opflags);
+
+    /* set operation csn if provided */
+    if (opcsn) {
+        slapi_pblock_get (newpb, SLAPI_OPERATION, &op);
+        operation_set_csn (op, opcsn);
+    }
+    if (parentuniqueid) {
+        struct slapi_operation_parameters *op_params;
+        slapi_pblock_get( newpb, SLAPI_OPERATION_PARAMETERS, &op_params );
+        op_params->p.p_modrdn.modrdn_newsuperior_address.uniqueid = (char*)parentuniqueid;
+    }
+    slapi_modrdn_internal_pb(newpb); 
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+
+    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
+                  "urp_fixup_modrdn_entry: moving entry (%s) result %d\n",
+                  slapi_sdn_get_dn(entrydn), op_result);
+    slapi_pblock_destroy(newpb);
+    return op_result;
+}
+
+int
 urp_fixup_rename_entry(const Slapi_Entry *entry, const char *newrdn, const char *parentuniqueid, int opflags)
 {
     Slapi_PBlock *newpb;
